'=============================================================================
' Copyright  Micromega Corporation 2005-2007. All rights reserved.
'
' @file		template-spi.bsp
' @target	PICBASIC PRO
'
' This program provides an example of using the uM-FPU V3.1 floating point
' coprocessor with the PICBASIC PRO compiler using an SPI interface. It shows
' the initial FPU reset sequence and prints the version number of the FPU chip.
'
' @author Cam Thompson, Micromega Corporation
' @version
'	October 11, 2007
'	- original version
'=============================================================================

'-------------------- PIC oscillator speed ------------------------------------
define      OSC 20                      ' specify the speed of the oscillator
OSC_SPEED   con 20                      ' define PICBASIC constant

'-------------------- debug definitions ---------------------------------------
define      DEBUG_REG   PORTC
define      DEBUG_BIT   6
define      DEBUG_BAUD  19200
define      DEBUG_MODE  0

'-------------------- uM-FPU pin definitions ----------------------------------
FpuClk          var     PORTC.3			' SPI SCLK (uM-FPU SCLK)
FpuIn           var     PORTC.4			' SPI MISO (uM-FPU SOUT)
FpuOut          var     PORTC.5			' SPI MOSI (uM-FPU SIN)

include     "umfpuV3-spi.bas"           ' include uM-FPU V3.1 support routines

'-------------------- uM-FPU register definitions ----------------------------


'-------------------- variables ----------------------------------------------


'=============================================================================
'-------------------- initialization -----------------------------------------
'=============================================================================

Reset:
  DEBUG 13, 10, 13, 10, "SPI template", 13, 10

  GOSUB Fpu_Reset                       ' initialize uM-FPU
  IF fpu_status <> SYNC_CHAR THEN
    DEBUG "uM-FPU not detected."
    END
  ELSE
    GOSUB Print_Version                 ' display version string
	DEBUG 13, 10
  ENDIF

'=============================================================================
'-------------------- main routine -------------------------------------------
'=============================================================================

Main:
'	Insert main application code here.
'	FPU instructions are sent using an SHIFTOUT instruction.
'	e.g.
'		SHIFTOUT FpuOut, FpuClk, MSBFIRST, [SELECTA, 1, LOADPI, FSET0]

Done:
	DEBUG 13, 10, "Done.", 13, 10
	END